package cz.muni.fi.pv217.resource;

import cz.muni.fi.pv217.model.LicensePlatePass;
import cz.muni.fi.pv217.service.DistributorService;
import org.eclipse.microprofile.rest.client.inject.RestClient;
import org.jboss.logging.Logger;
import org.jboss.resteasy.reactive.RestResponse;

import io.micrometer.core.instrument.MeterRegistry;

import javax.enterprise.context.ApplicationScoped;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import java.time.Instant;

@Path("/mock")
@ApplicationScoped
public class MockGeneratorResource {

    @RestClient
    DistributorService distributorService;

    private static final Logger LOG = Logger.getLogger(MockGeneratorResource.class);

    private final MeterRegistry registry;

    MockGeneratorResource(MeterRegistry registry) {
        this.registry = registry;
    }

    @GET
    @Produces(MediaType.TEXT_PLAIN)
    public RestResponse startMock() {
        registry.counter("mocking.mock").increment();
        LOG.info("Generation started");
        distributorService.distributeLicencePlate(new LicensePlatePass("6E60334", Instant.now(), "Brno"));
        distributorService.distributeLicencePlate(new LicensePlatePass("5B03342", Instant.now(), "Brno"));
        distributorService.distributeLicencePlate(new LicensePlatePass("3AE0334", Instant.now(), "Brno"));
        distributorService.distributeLicencePlate(new LicensePlatePass("IL485BA", Instant.now(), "Praha"));
        distributorService.distributeLicencePlate(new LicensePlatePass("ERA75TM", Instant.now(), "Ostrava"));
        distributorService.distributeLicencePlate(new LicensePlatePass("3AE0334", Instant.now(), "Praha"));
        distributorService.distributeLicencePlate(new LicensePlatePass("2BA3333", Instant.now(), "Pardubice"));
        distributorService.distributeLicencePlate(new LicensePlatePass("1E81322", Instant.now(), "Brno"));
        LOG.info("Generation ended");
        return RestResponse.ResponseBuilder.ok().build();
    }
}